crashpad::ProcessSnapshotSanitized Class Referencefinal

A ProcessSnapshot which wraps and filters sensitive information from another ProcessSnapshot. More...

`#include "snapshot/sanitized/process_snapshot_sanitized.h"`

Inheritance diagram for crashpad::ProcessSnapshotSanitized:

## Public Member Functions

bool | Initialize (const ProcessSnapshot *snapshot, const std::vector< std::string > *annotations_whitelist, VMAddress target_module_address, bool sanitize_stacks)
| Initializes this object. More...
pid_t | ProcessID () const override
| Returns the snapshot process’ process ID.
pid_t | ParentProcessID () const override
| Returns the snapshot process’ parent process’ process ID.
void | SnapshotTime (timeval *snapshot_time) const override
| Returns the time that the snapshot was taken in snapshot_time. More...
void | ProcessStartTime (timeval *start_time) const override
| Returns the time that the snapshot process was started in start_time. More...
void | ProcessCPUTimes (timeval *user_time, timeval *system_time) const override
| Returns the snapshot process’ CPU usage times in user_time and system_time. More...
void | ReportID (UUID *report_id) const override
| Returns a UUID identifying the event that the snapshot describes. More...
void | ClientID (UUID *client_id) const override
| Returns a UUID identifying the client that the snapshot represents. More...
const std::map< std::string, std::string > & | AnnotationsSimpleMap () const override
| Returns key-value string annotations recorded for the process, system, or snapshot producer. More...
const SystemSnapshot * | System () const override
| Returns a SystemSnapshot reflecting the characteristics of the system that ran the snapshot process at the time of the snapshot. More...
std::vector< const ThreadSnapshot * > | Threads () const override
| Returns ThreadSnapshot objects reflecting the threads (lightweight processes) existing in the snapshot process at the time of the snapshot. More...
std::vector< const ModuleSnapshot * > | Modules () const override
| Returns ModuleSnapshot objects reflecting the code modules (binary images) loaded into the snapshot process at the time of the snapshot. More...
std::vector< UnloadedModuleSnapshot > | UnloadedModules () const override
| Returns UnloadedModuleSnapshot objects reflecting the code modules the were recorded as unloaded at the time of the snapshot. More...
const ExceptionSnapshot * | Exception () const override
| Returns an ExceptionSnapshot reflecting the exception that the snapshot process sustained to trigger the snapshot being taken. More...
std::vector< const MemoryMapRegionSnapshot * > | MemoryMap () const override
| Returns MemoryMapRegionSnapshot objects reflecting the regions of the memory map in the snapshot process at the time of the snapshot. More...
std::vector< HandleSnapshot > | Handles () const override
| Returns HandleSnapshot objects reflecting the open handles in the snapshot process at the time of the snapshot. More...
std::vector< const MemorySnapshot * > | ExtraMemory () const override
| Returns a vector of additional memory blocks that should be included in a minidump. More...

## Detailed Description

A ProcessSnapshot which wraps and filters sensitive information from another ProcessSnapshot.

## Member Function Documentation

## AnnotationsSimpleMap()

const std::map< std::string, std::string > & crashpad::ProcessSnapshotSanitized::AnnotationsSimpleMap | ( |  | ) | const

overridevirtual

Returns key-value string annotations recorded for the process, system, or snapshot producer.

This method retrieves annotations recorded for a process. These annotations are intended for diagnostic use, including crash analysis. “Simple annotations” are structured as a sequence of key-value pairs, where all keys and values are strings. These are referred to in Chrome as “crash keys.”

Annotations stored here may reflect the process, system, or snapshot producer. Most annotations not under the client’s direct control will be retrievable by this method. For clients such as Chrome, this includes the product name and version.

Additional per-module annotations may be obtained by calling ModuleSnapshot::AnnotationsSimpleMap().

Implements crashpad::ProcessSnapshot.

## ClientID()

void crashpad::ProcessSnapshotSanitized::ClientID | ( | UUID * | client_id | ) | const

overridevirtual

Returns a UUID identifying the client that the snapshot represents.

Client identification is within the scope of the application, but it is expected that the identifier will be unique for an instance of Crashpad monitoring an application or set of applications for a user. The identifier shall remain stable over time.

If no identifier is available, this field will contain zeroes.

Implements crashpad::ProcessSnapshot.

## Exception()

const ExceptionSnapshot * crashpad::ProcessSnapshotSanitized::Exception | ( |  | ) | const

overridevirtual

Returns an ExceptionSnapshot reflecting the exception that the snapshot process sustained to trigger the snapshot being taken.

Returns
  An ExceptionSnapshot object. The caller does not take ownership of this object, it is scoped to the lifetime of the ProcessSnapshot object that it was obtained from. If the snapshot is not a result of an exception, returns `nullptr`.

Implements crashpad::ProcessSnapshot.

## ExtraMemory()

std::vector< const MemorySnapshot * > crashpad::ProcessSnapshotSanitized::ExtraMemory | ( |  | ) | const

overridevirtual

Returns a vector of additional memory blocks that should be included in a minidump.

Returns
  An vector of MemorySnapshot objects that will be included in the crash dump. The caller does not take ownership of these objects, they are scoped to the lifetime of the ProcessSnapshot object that they were obtained from.

Implements crashpad::ProcessSnapshot.

## Handles()

std::vector< HandleSnapshot > crashpad::ProcessSnapshotSanitized::Handles | ( |  | ) | const

overridevirtual

Returns HandleSnapshot objects reflecting the open handles in the snapshot process at the time of the snapshot.

Returns
  A vector of HandleSnapshot objects.

Implements crashpad::ProcessSnapshot.

## Initialize()

bool crashpad::ProcessSnapshotSanitized::Initialize | ( | const ProcessSnapshot * | snapshot,
|  | const std::vector< std::string > * | annotations_whitelist,
|  | VMAddress | target_module_address,
|  | bool | sanitize_stacks
| ) |  |

Initializes this object.

This method must be successfully called before calling any other method on this object.

Parameters

  [in] | snapshot | The ProcessSnapshot to sanitize.
  [in] | annotations_whitelist | A list of annotations names to allow to be returned by AnnotationsSimpleMap() or from this object's module snapshots. If `nullptr`, all annotations will be returned.
  [in] | target_module_address | An address in the target process' address space within the bounds of a module to target. If the crashing thread's context and stack do not contain any pointers into this module's address range, this method will return `false`. If this value is 0, this method will not check the context or stack for references to any particular module.
  [in] | sanitize_stacks | If `true`, the MemorySnapshots for each thread's stack will be filtered using an internal::StackSnapshotSanitized.

Returns
  `false` if snapshot does not meet sanitization requirements and should be filtered entirely. Otherwise `true`.

## MemoryMap()

std::vector< const MemoryMapRegionSnapshot * > crashpad::ProcessSnapshotSanitized::MemoryMap | ( |  | ) | const

overridevirtual

Returns MemoryMapRegionSnapshot objects reflecting the regions of the memory map in the snapshot process at the time of the snapshot.

Returns
  A vector of MemoryMapRegionSnapshot objects. The caller does not take ownership of these objects, they are scoped to the lifetime of the ProcessSnapshot object that they were obtained from.

Implements crashpad::ProcessSnapshot.

## Modules()

std::vector< const ModuleSnapshot * > crashpad::ProcessSnapshotSanitized::Modules | ( |  | ) | const

overridevirtual

Returns ModuleSnapshot objects reflecting the code modules (binary images) loaded into the snapshot process at the time of the snapshot.

Returns
  A vector of ModuleSnapshot objects. The caller does not take ownership of these objects, they are scoped to the lifetime of the ProcessSnapshot object that they were obtained from.

Implements crashpad::ProcessSnapshot.

## ProcessCPUTimes()

void crashpad::ProcessSnapshotSanitized::ProcessCPUTimes | ( | timeval * | user_time,
|  | timeval * | system_time
| ) |  | const

overridevirtual

Returns the snapshot process’ CPU usage times in user_time and system_time.

Parameters

  [out] | user_time | The time that the process has spent executing in user mode.
  [out] | system_time | The time that the process has spent executing in system (kernel) mode.

Implements crashpad::ProcessSnapshot.

## ProcessStartTime()

void crashpad::ProcessSnapshotSanitized::ProcessStartTime | ( | timeval * | start_time | ) | const

overridevirtual

Returns the time that the snapshot process was started in start_time.

Normally, process uptime in wall clock time can be computed as SnapshotTime() − ProcessStartTime(), but this cannot be guaranteed in cases where the real-time clock has been set during the snapshot process’ lifetime.

Parameters

  [out] | start_time | The time that the process was started.

Implements crashpad::ProcessSnapshot.

## ReportID()

void crashpad::ProcessSnapshotSanitized::ReportID | ( | UUID * | client_id | ) | const

overridevirtual

Returns a UUID identifying the event that the snapshot describes.

This provides a stable identifier for a crash even as the report is converted to different formats, provided that all formats support storing a crash report ID. When a report is originally created, a report ID should be assigned. From that point on, any operations involving the same report should preserve the same report ID.

If no identifier is available, this field will contain zeroes.

Implements crashpad::ProcessSnapshot.

## SnapshotTime()

void crashpad::ProcessSnapshotSanitized::SnapshotTime | ( | timeval * | snapshot_time | ) | const

overridevirtual

Returns the time that the snapshot was taken in snapshot_time.

Parameters

  [out] | snapshot_time | The time that the snapshot was taken. This is distinct from the time that a ProcessSnapshot object was created or initialized, although it may be that time for ProcessSnapshot objects representing live or recently-crashed process state.

Implements crashpad::ProcessSnapshot.

## System()

const SystemSnapshot * crashpad::ProcessSnapshotSanitized::System | ( |  | ) | const

overridevirtual

Returns a SystemSnapshot reflecting the characteristics of the system that ran the snapshot process at the time of the snapshot.

Returns
  A SystemSnapshot object. The caller does not take ownership of this object, it is scoped to the lifetime of the ProcessSnapshot object that it was obtained from.

Implements crashpad::ProcessSnapshot.

## Threads()

std::vector< const ThreadSnapshot * > crashpad::ProcessSnapshotSanitized::Threads | ( |  | ) | const

overridevirtual

Returns ThreadSnapshot objects reflecting the threads (lightweight processes) existing in the snapshot process at the time of the snapshot.

Returns
  A vector of ThreadSnapshot objects. The caller does not take ownership of these objects, they are scoped to the lifetime of the ProcessSnapshot object that they were obtained from.

Implements crashpad::ProcessSnapshot.

## UnloadedModules()

std::vector< UnloadedModuleSnapshot > crashpad::ProcessSnapshotSanitized::UnloadedModules | ( |  | ) | const

overridevirtual

Returns UnloadedModuleSnapshot objects reflecting the code modules the were recorded as unloaded at the time of the snapshot.

Returns
  A vector of UnloadedModuleSnapshot objects.

Implements crashpad::ProcessSnapshot.

The documentation for this class was generated from the following files:

- snapshot/sanitized/process_snapshot_sanitized.h
- snapshot/sanitized/process_snapshot_sanitized.cc